<template>
  <section class="section">
    <div class="columns">
      <div class="column is-5">
        <p
          v-if="displacements === null || displacements.length < 1"
          class="alert-message"
        >
          Aucune réservation en cours
        </p>
        <ul v-else>
          <li
            v-for="(displacement, index) in displacements"
            :key="index"
          >
            <ride-card
              v-if="displacement.passengersCount"
              :ride="displacement"
              cancelable
              @delete-ride="toggleModal"
            />
            <shuttle-card
              v-else
              :shuttle="displacement"
              cancelable
              @delete-shuttle="toggleModal"
            />
          </li>
        </ul>
      </div>
    </div>
    <modal
      :active="isModalActive"
      title="Suppression de la course"
      content="Êtes-vous sûr de vouloir supprimer cette course ?"
      @toggle-modal="toggleModal"
      @action="deleteDisplacement"
    />
  </section>
</template>

<script>
import { CANCEL_REQUESTED_CUSTOMER } from '@fabnumdef/e-chauffeur_lib-vue/api/status/states';
import modal from '~/components/modal.vue';
import rideCard from '~/components/cards/ride.vue';
import shuttleCard from '~/components/cards/shuttle.vue';
import FilterManager from '~/helpers/filter-manager';

const filterManager = new FilterManager(2019);
const currents = filterManager.getCurrents();

const RIDE_MASK = 'id,departure(label),arrival(label),start,luggage,passengersCount,status,campus';
const SHUTTLE_MASK = 'id,passengers,start,status,campus';

const formatData = (displacements) => displacements.map((displacement) => {
  const { day, hour } = (FilterManager.formatDate(displacement.createdAt));
  return {
    ...displacement,
    day,
    hour,
  };
});

export default {
  components: {
    shuttleCard,
    rideCard,
    modal,
  },
  async asyncData({ $api, $auth }) {
    // @todo: start/end should not be relative to month here,
    // but start should be `current date - 30d` and end should be `now`
    const { start, end } = FilterManager.getFilter(currents);
    const [{ data: batchA }, { data: batchB }] = await Promise.all([
      $api.query('rides')
        .setMask(RIDE_MASK)
        .list(start, end)
        .setFilter('userId', $auth.user.id)
        .setFilter('current', true),
      $api.query('shuttles')
        .setMask(SHUTTLE_MASK)
        .list(start, end)
        .setFilter('passengerId', $auth.user.id)
        .setFilter('current', true),
    ]);

    return {
      displacements: [...formatData(batchA), ...formatData(batchB)].sort((a, b) => (a.start < b.start ? 1 : -1)),
    };
  },
  data() {
    return {
      isModalActive: false,
      currentRide: null,
    };
  },
  methods: {
    toggleModal(id) {
      this.isModalActive = !this.isModalActive;
      if (id) {
        [this.currentDisplacement] = this.displacements.filter((d) => d.id === id);
      }
    },
    deleteRideReservation() {
      return this.$api.query('rides').mutate(this.currentDisplacement.id, CANCEL_REQUESTED_CUSTOMER);
    },
    deleteShuttleReservation() {
      return this.$api.query('shuttles')
        .mutatePassenger(this.currentDisplacement.id, CANCEL_REQUESTED_CUSTOMER, this.$auth.user.id);
    },
    async deleteDisplacement() {
      try {
        const request = this.currentDisplacement.passengersCount
          ? this.deleteRideReservation
          : this.deleteShuttleReservation;
        await request();
        this.$toast.success('Réservation supprimée avec succès');
      } catch (err) {
        this.$toast.error('Une erreur est survenue lors de la suppression.');
      }

      this.toggleModal();
      // @todo: start/end should not be relative to month here,
      // but start should be `current date - 30d` and end should be `now`
      const { start, end } = FilterManager.getFilter(currents);
      const [{ data: batchA }, { data: batchB }] = await Promise.all([
        this.$api.query('rides')
          .setMask(RIDE_MASK)
          .list(start, end)
          .setFilter('userId', this.$auth.user.id)
          .setFilter('current', true),
        this.$api.query('shuttles')
          .setMask(SHUTTLE_MASK)
          .list(start, end)
          .setFilter('userId', this.$auth.user.id)
          .setFilter('current', true),
      ]);

      this.displacements = [...formatData(batchA), ...formatData(batchB)].sort((a, b) => (a.start < b.start ? -1 : 1));
    },
  },
};
</script>

<style lang="scss" scoped>
  div.columns {
    margin-top: 2em;
  }
</style>
